JUCE: KeyGeneration Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Static Public Member Functions | List of all members
KeyGeneration Class Reference
juce_product_unlocking » marketplace

Contains static utilities for generating key-files that can be unlocked by the OnlineUnlockStatus class. More...

`#include <juce_KeyFileGeneration.h>`

## Static Public Member Functions
static String JUCE_CALLTYPE | generateKeyFile (const String &appName, const String &userEmail, const String &userName, const String &machineNumbers, const RSAKey &privateKey)
| Generates the content of a key-file which can be sent to a user's machine to unlock a product.
static String JUCE_CALLTYPE | generateExpiringKeyFile (const String &appName, const String &userEmail, const String &userName, const String &machineNumbers, const Time expiryTime, const RSAKey &privateKey)
| Similar to the above key file generation method but with an expiry time.
static int | keyGenerationAppMain (int argc, char *argv[])
| This is a simple implementation of a key-generator that you could easily wrap in a command-line main() function for use on your server.

## Detailed Description

Contains static utilities for generating key-files that can be unlocked by the OnlineUnlockStatus class.

## Member Function Documentation

## ◆ generateKeyFile()

static String JUCE_CALLTYPE KeyGeneration::generateKeyFile | ( | const String & | appName,
|  | const String & | userEmail,
|  | const String & | userName,
|  | const String & | machineNumbers,
|  | const RSAKey & | privateKey
| ) |  |
| static

Generates the content of a key-file which can be sent to a user's machine to unlock a product.

The returned value is a block of text containing an RSA-encoded block, followed by some human-readable details. If you pass this block of text to OnlineUnlockStatus::applyKeyFile(), it will decrypt it, and if the key matches and the machine numbers match, it will unlock that machine.

Typically the way you'd use this on a server would be to build a small executable that simply calls this method and prints the result, so that the webserver can use this as a reply to the product's auto-registration mechanism. The keyGenerationAppMain() function is an example of how to build such a function.

See also
  OnlineUnlockStatus

## ◆ generateExpiringKeyFile()

static String JUCE_CALLTYPE KeyGeneration::generateExpiringKeyFile | ( | const String & | appName,
|  | const String & | userEmail,
|  | const String & | userName,
|  | const String & | machineNumbers,
|  | const Time | expiryTime,
|  | const RSAKey & | privateKey
| ) |  |
| static

Similar to the above key file generation method but with an expiry time.

You must supply a Time after which this key file should no longer be considered as active.

N.B. when an app is unlocked with an expiring key file, OnlineUnlockStatus::isUnlocked will still return false. You must then check OnlineUnlockStatus::getExpiryTime to see if this expiring key file is still in date and act accordingly.

See also
  OnlineUnlockStatus

## ◆ keyGenerationAppMain()

static int KeyGeneration::keyGenerationAppMain | ( | int | argc,
|  | char * | argv[]
| ) |  |
| static

This is a simple implementation of a key-generator that you could easily wrap in a command-line main() function for use on your server.

So for example you might use this in a command line app called "unlocker" and then call it like this:

unlocker MyGreatApp joebl.nosp@m.oggs.nosp@m.@foob.nosp@m.ar.c.nosp@m.om Joe_Bloggs 1234abcd,95432ff 22d9aec92d986dd1,923ad49e9e7ff294c

References StringArray::add(), and StringArray::size().

The documentation for this class was generated from the following file:

- juce_KeyFileGeneration.h